// Generated automatically by nearley, version 2.20.1
// http://github.com/Hardmath123/nearley
(function () {
function id(x) { return x[0]; }

const ast = require("./ast.js");     // Import the AST module
var grammar = {
    Lexer: undefined,
    ParserRules: [
    {"name": "sequent", "symbols": ["expression"], "postprocess": id},
    {"name": "sequent", "symbols": ["_", "turnstile", "_", "conclusions"], "postprocess":  
        function(data) {
            return [[], data[3]];
        } 
            },
    {"name": "sequent", "symbols": ["givens", "_", "turnstile", "_", "conclusions"], "postprocess":  
        function(data) {
            return [data[0], data[4]]; // Return a tuple [givens, conclusion]
        } 
            },
    {"name": "givens$ebnf$1", "symbols": []},
    {"name": "givens$ebnf$1$subexpression$1", "symbols": [{"literal":","}, "_", "given"]},
    {"name": "givens$ebnf$1", "symbols": ["givens$ebnf$1", "givens$ebnf$1$subexpression$1"], "postprocess": function arrpush(d) {return d[0].concat([d[1]]);}},
    {"name": "givens", "symbols": ["given", "givens$ebnf$1"], "postprocess":  
        function(data) {
            let result = [data[0]]; 
            for (let i = 0; i < data[1].length; i++) {
                result.push(data[1][i][2]); 
            }
            return result; 
        }
        },
    {"name": "given", "symbols": ["expression"], "postprocess": id},
    {"name": "conclusions$ebnf$1", "symbols": []},
    {"name": "conclusions$ebnf$1$subexpression$1", "symbols": [{"literal":","}, "_", "conclusion"]},
    {"name": "conclusions$ebnf$1", "symbols": ["conclusions$ebnf$1", "conclusions$ebnf$1$subexpression$1"], "postprocess": function arrpush(d) {return d[0].concat([d[1]]);}},
    {"name": "conclusions", "symbols": ["conclusion", "conclusions$ebnf$1"], "postprocess":  
        function(data) {
            let result = [data[0]]; 
            for (let i = 0; i < data[1].length; i++) {
                result.push(data[1][i][2]); 
            }
            return result;
        }
        },
    {"name": "conclusion", "symbols": ["expression"], "postprocess": id},
    {"name": "expression", "symbols": ["implication"], "postprocess": id},
    {"name": "implication$string$1", "symbols": [{"literal":"-"}, {"literal":">"}], "postprocess": function joiner(d) {return d.join('');}},
    {"name": "implication", "symbols": ["or", "_", "implication$string$1", "_", "implication"], "postprocess": function(data) { return ast.Imply(data[2], data[0], data[4]); }},
    {"name": "implication", "symbols": ["or"], "postprocess": id},
    {"name": "or$string$1", "symbols": [{"literal":"|"}, {"literal":"|"}], "postprocess": function joiner(d) {return d.join('');}},
    {"name": "or", "symbols": ["or", "_", "or$string$1", "_", "and"], "postprocess": function(data) { return ast.Or(data[2], data[0], data[4]); }},
    {"name": "or", "symbols": ["and"], "postprocess": id},
    {"name": "and", "symbols": ["and", "_", {"literal":"&"}, "_", "not"], "postprocess": function(data) { return ast.And(data[2], data[0], data[4]); }},
    {"name": "and", "symbols": ["not"], "postprocess": id},
    {"name": "not", "symbols": [{"literal":"!"}, "_", "not"], "postprocess": function(data) { return ast.Not(data[0], data[2], null); }},
    {"name": "not", "symbols": ["primary"], "postprocess": id},
    {"name": "primary", "symbols": [{"literal":"("}, "_", "expression", "_", {"literal":")"}], "postprocess": function(data) { return data[2]; }},
    {"name": "primary", "symbols": ["TRUE"], "postprocess": id},
    {"name": "primary", "symbols": ["FALSE"], "postprocess": id},
    {"name": "primary", "symbols": ["symbol"], "postprocess": id},
    {"name": "turnstile$string$1", "symbols": [{"literal":"|"}, {"literal":"-"}], "postprocess": function joiner(d) {return d.join('');}},
    {"name": "turnstile", "symbols": ["turnstile$string$1"], "postprocess": id},
    {"name": "TRUE$string$1", "symbols": [{"literal":"t"}, {"literal":"r"}, {"literal":"u"}, {"literal":"e"}], "postprocess": function joiner(d) {return d.join('');}},
    {"name": "TRUE", "symbols": ["TRUE$string$1"], "postprocess": function() { return ast.True(1, null, null); }},
    {"name": "FALSE$string$1", "symbols": [{"literal":"f"}, {"literal":"a"}, {"literal":"l"}, {"literal":"s"}, {"literal":"e"}], "postprocess": function joiner(d) {return d.join('');}},
    {"name": "FALSE", "symbols": ["FALSE$string$1"], "postprocess": function() { return ast.False(0, null, null); }},
    {"name": "symbol", "symbols": [/[a-zA-Z]/], "postprocess": function(data) { return ast.Symbol(data[0], null, null); }},
    {"name": "_", "symbols": []},
    {"name": "_", "symbols": ["_", /[\s]/]}
]
  , ParserStart: "sequent"
}
if (typeof module !== 'undefined'&& typeof module.exports !== 'undefined') {
   module.exports = grammar;
} else {
   window.grammar = grammar;
}
})();
